package com.landray.kmss.sys.attachment.plugin.customPage.util;

import java.util.Iterator;
import com.landray.kmss.util.StringUtil;
import javax.servlet.http.HttpServletRequest;
import com.landray.kmss.framework.plugin.core.config.IExtension;
import com.landray.kmss.sys.attachment.plugin.customPage.service.ISysAttCustomPageService;
import java.util.ArrayList;
import com.landray.kmss.framework.service.plugin.Plugin;
import com.landray.kmss.sys.attachment.plugin.customPage.model.SysAttCustomPagePlugin;
import java.util.List;

public class SysAttCustomPageUtil
{
    private static final String customPage = "com.landray.kmss.sys.attachment.custom.page";
    private static List<SysAttCustomPagePlugin> extensionList;
    
    static {
        SysAttCustomPageUtil.extensionList = null;
    }
    
    public static List<SysAttCustomPagePlugin> getExtensionList() {
        if (SysAttCustomPageUtil.extensionList == null) {
            final IExtension[] extensions = Plugin.getExtensions("com.landray.kmss.sys.attachment.custom.page", "*", "customPage");
            SysAttCustomPageUtil.extensionList = new ArrayList<SysAttCustomPagePlugin>();
            IExtension[] array;
            for (int length = (array = extensions).length, i = 0; i < length; ++i) {
                final IExtension extension = array[i];
                final SysAttCustomPagePlugin plugin = new SysAttCustomPagePlugin();
                plugin.setKey(Plugin.getParamValueString(extension, "key"));
                plugin.setName(Plugin.getParamValueString(extension, "name"));
                plugin.setProvider((ISysAttCustomPageService)Plugin.getParamValue(extension, "provider"));
                SysAttCustomPageUtil.extensionList.add(plugin);
            }
        }
        return SysAttCustomPageUtil.extensionList;
    }
    
    public static String getCustomPage(final HttpServletRequest request) throws Exception {
        String customPageUrl = "";
        final List<SysAttCustomPagePlugin> plugins = getExtensionList();
        if (plugins != null && plugins.size() > 0) {
            for (final SysAttCustomPagePlugin plugin : plugins) {
                final String fdKey = plugin.getKey();
                if (StringUtil.isNotNull(fdKey)) {
                    final ISysAttCustomPageService provider = plugin.getProvider();
                    customPageUrl = provider.getCustomPageUrl(request);
                    if (StringUtil.isNotNull(customPageUrl)) {
                        break;
                    }
                    continue;
                }
            }
        }
        return customPageUrl;
    }
}
